#include <bases.h>

asm("
| the stack consists of a single linked linear list like this:
|
| struct stack
| { struct stack *next;			points to the next underlying structure
|   struct StackSwapStruct sss;		holds previous stackframe when used,
|					itself when unused, the current stackborders
|					are in the task structure ;-)
|   APTR top_of_stackframe; }		previous variable value
|					Note: stack->sss.stk_Lower is not reliable
|
| For better performance stackframes are cached in a 'unused' list when
| not in use. (AllocMem() is really a performance killer).
|

|
| Caution:
| Race condition ahead! exec might preempt our task at any time storing
| the current register set on top of the free stack. NEVER set a sp higher
| than the location of important data.
|
	.comm	___used_stack,8		| pointer to used stackframes,
					| pointer to unused stackframes
	.text
	.even
	.globl	___stkrst

___stkrst:
	movel	a2,sp@-
	moveml	#0x40f6,sp@-
	movel	sp,a2
	movel	d0,a3
	lea	"A4(___used_stack)",a5
	tstl	a5@
	jeq	l0			| No previous stackframe
l2:	movel	"A4(___stackborders)",a0
	cmpl	a0@,a3
	jcs	l1
	cmpl	a0@(4:W),a3
	jle	l0			| Stackpointer points to current frame
l1:	movel	"A4(_SysBase)",a6	| Go to previous stack
	movel	a5,a1
	movel	a1@,a0
	movel	a0@,a1@+
	movel	a1@,a0@
	movel	a0,a1@
	addqw	#4,a0
	movel	a0@(12:W),"A4(___stk_limit)"
	jsr	a6@(-0x2dc)		| StackSwap(sss:a0)
	subqw	#4,sp			| Avoid overwriting returnaddress
	tstl	a5@
	jne	l2
l0:	movel	a2@(32:W),a3@-		| Store returnaddress
	movel	a3,d0
	moveml	a2@+,#0x6f02		| Restore registers
	movel	a2@,a2
	movel	d0,sp			| Set stackpointer AFTER restoring registers!
	addql	#4,d0			| This function may return on the same
	rts				| stackframe it was called on.
");
